/* Written by Arjan Meskers - 2001
// Modified by Menashe Dickman - 2001
// Congrats! Add-in
// Displays all anniversaries or birthdays
// **
// Events must be noted in the calendar the following way:
// Name's Anniversary or Name's Birthday
// Name = max. 30 char.
// **/

#include <rex/rex.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "congrats.h"


main() {
	/* Declares */
	MSG msg;
	int flag, repeat, line = 3;

	/* Program */
	numRecords = recordType = sortField = 0;
	pos = maxPos = sortDir = 1;

	DsClearScreen();
	DsPrintf(10, 20, TEXT_NORMAL, "What would you like to display?");
	DsDialogTextButton(75,35,85,20,62,"Birthdays");
	DsDialogTextButton(75,57,85,20,63, "Anniversaries");
	DsDialogTextButton(75,90,85,20,64, "Exit");

	flag=1;
	while(flag) {
		DsEventMessageGet(msg);
		switch (msg.message) {
		case MSG_DS_CLOSE:
			flag=0;
			break;
		case MSG_DS_KEY_DOWN:
			switch ( msg.sCode ) {
			case KEY_TOP_C:
				DsClearScreen();
				DsAddinTerminate();
				break;
			case KEY_BACK_A	:
				break;
			case KEY_ENTER_A:
				break;
			case KEY_UP_A:
				if (pos > 0) {
					pos -= LINES_PER_PAGE;
					DsDisplayBlockClear(0, 12, 220, 120);
					if (pos < 0)
						pos = 0;
					DsDialogScrollThumbSet(pos);
					displayRecords();
				}
				break;
			case KEY_DOWN_A:
				if (pos < maxPos) {
					pos += LINES_PER_PAGE;
					DsDisplayBlockClear(0, 12, 220, 120);	
					if (pos > maxPos)
						pos = maxPos;
					DsDialogScrollThumbSet(pos);
					displayRecords();
				}
				break;
			}
			break;
		case MSG_DS_PAINT:
			break;
		case MSG_DS_COMMAND:
			switch (msg.bCode) {
			case MSG_DS_SCROLL_THUMB:
				DsDisplayBlockClear(0, 12, 220, 120);	
				pos = msg.sCode;
				DsDialogScrollThumbSet(pos);
				displayRecords();
				break;
			case MSG_DS_SCROLLUP:
			case MSG_DS_SCROLLUP_REPEAT:
				if (pos > 0) {
					pos--;
					DsDisplayBlockClear(0, 12, 220, 120);
					DsDialogScrollThumbSet(pos);
					displayRecords();
				}
				break;
			case MSG_DS_SCROLLDOWN:
			case MSG_DS_SCROLLDOWN_REPEAT:
				if (pos < maxPos) {
					pos++;
					DsDisplayBlockClear(0, 12, 220, 120);
					DsDialogScrollThumbSet(pos);
					displayRecords();
				}
				break;
			case 61:
				DsDisplayBlockReverse(227,1,10,10,0);
				DsSleep(10);
				DsEventClear();
				DsClearScreen();
				for (repeat = 0; repeat < numRecords; repeat++)
					DsFree(records[repeat]);
				DsAddinTerminate();
				break;
			case 62:
				DsDisplayBlockReverse(75,35,85,20,0);
				DsSleep(10);
				DsEventClear();
				DsEventAdd(1, 1, 129, 10, 65, 1);
				DsEventAdd(130, 1, 29, 10, 66, 1);
				DsEventAdd(160, 1, 66, 10, 67, 1);
				DsEventAdd(227, 1, 10, 10, 61, 1);
				recordType = 1;				
				ReadAndDisplayRecords(recordType);
				break;
			case 63:
				DsDisplayBlockReverse(75,57,85,20,0);
				DsSleep(10);
				DsEventClear();
				DsEventAdd(1, 1, 119, 10, 65, 1);
				DsEventAdd(120, 1, 39, 10, 66, 1);
				DsEventAdd(160, 1, 66, 10, 67, 1);
				DsEventAdd(227, 1, 10, 10, 61, 1);
				recordType = 2;
				ReadAndDisplayRecords(recordType);
				break;
			case 64:
				DsDisplayBlockReverse(75,90,85,20,0);
				DsSleep(10);
				DsEventClear();
				DsClearScreen();
				DsAddinTerminate();
				break;
			case 65:
				if (recordType == 1) {
					DsDisplayBlockReverse(1, 1, 129, 10, 0);
					DsSleep(10);
					DsDisplayBlockReverse(1, 1, 129, 10, 0);
				} else {
					DsDisplayBlockReverse(1, 1, 119, 10, 0);
					DsSleep(10);
					DsDisplayBlockReverse(1, 1, 119, 10, 0);
				}
				DsDisplayBlockClear(0, 12, 220, 120);

				/* If second time on a row on this field, sort in reverse */
				if (sortField == 1) {
					sortDir = -sortDir;
				} else {
					sortDir = 1;
				}
				sortField = 1;
				quicksort(0, numRecords - 1);
				displayRecords();
				break;
			case 66:
				if (recordType == 1) {
					DsDisplayBlockReverse(130, 1, 29, 10, 0);
					DsSleep(10);
					DsDisplayBlockReverse(130, 1, 29, 10, 0);
				} else {
					DsDisplayBlockReverse(120, 1, 39, 10, 0);
					DsSleep(10);
					DsDisplayBlockReverse(120, 1, 39, 10, 0);
				}
				DsDisplayBlockClear(0, 12, 220, 120);

				if (sortField == 2) {
					sortDir = -sortDir;
				} else {
					sortDir = 1;
				}
				sortField = 2;
				quicksort(0, numRecords - 1);
				displayRecords();
				break;
			case 67:
				DsDisplayBlockReverse(160, 1, 66, 10, 0);
				DsSleep(10);
				DsDisplayBlockReverse(160, 1, 66, 10, 0);
				DsDisplayBlockClear(0, 12, 220, 120);

				if (sortField == 0) {
					sortDir = -sortDir;
				} else {
					sortDir = 1;
				}
				sortField = 0;
				quicksort(0, numRecords - 1);
				displayRecords();
				break;
			}
		}
	}
}

void ReadAndDisplayRecords(int type)
{
	CDATE currentDate;
	CTIME currentTime;

	char title[240];
	int eventDate[2];	
	char name[31], currentYear[5], eventType[12], isOurs[5];
	int dbHandle, repeat, recordId, len, ageInt, readRecords = 1, year, day, month, count = 0;
	
	DbBeginTransaction();
	dbHandle = DsDbOpen(DBID_CALENDAR);		/* Open calendar database */
	recordId = DbFindRecord(dbHandle, 1, 1, 0L);	/* find the first record */

	DsClearScreen();
	DsPrintf(100, 0, TEXT_BOLD, "Reading");
	DsDisplayLine(0, 11, 240, 0, LINE_SOLID);
	DsDisplayWaitIconDraw(1);

	numRecords = 0;
	while (readRecords == 1 && numRecords < 100) {
		DbReadField(dbHandle,CAL_SCHED_RPT_TYPE, &repeat);		/* Get repeat type of calendar item */
		if (repeat == CAL_RPT_YEARLY) {
			DbReadText(dbHandle, CAL_SCHED_TITLE, 0, 200, &len, &title[0]);	/* Get calendar item title */
			title[len] = '\0';

			if (type == 1) {
				substr(eventType, title, len - 8, len - 2);

				if (strcmp("Birthda", eventType)) {
					readRecords = DbNextRecord(dbHandle);
					continue;
				}

				substr(name, title, 0, len - 12);		/* Split title in name */

			} else if (type == 2) {
				substr(eventType, title, len - 11, len - 2);

				if (strcmp("Anniversar", eventType)) {
					readRecords = DbNextRecord(dbHandle);
					continue;
				}

				substr(isOurs, title, 0, 2);
				if (strcmp(isOurs, "Our"))
					substr(name, title, 0, len - 15);		/* Split title in name */
				else
					strcpy(name, "Ours");
			} else {
				readRecords = DbNextRecord(dbHandle);
				continue;
			}

			DbReadField(dbHandle,CAL_SCHED_DATE,&eventDate[0]);	/* Get event date */
	
			day = (eventDate[0] & 255);						/* Day in low byte */
			month = (eventDate[0] / 256);					/* Month in high byte */

			records[count] = (CRECORD *)DsMalloc(sizeof(CRECORD));

			strcpy(records[count]->name, name);
			records[count]->month = month;
			records[count]->day = day;

			/* Get current date */
			DsCalCurrentTime(currentDate, currentTime);

			/* If current date is after event, set date to next year */
			if ((month < currentDate.month) || 
				((month == currentDate.month) && (day < currentDate.day))) {
				currentDate.year += 1;
			} 
			records[count]->currYear = currentDate.year;

			ageInt = currentDate.year - eventDate[1];		

			/* Calculate age */
			records[count]->age = ageInt;

			count++;
		}
		readRecords = DbNextRecord(dbHandle);
	}

	numRecords = count;

	DsClearScreen();
	DsPrintf(100, 0, TEXT_BOLD, "Sorting");
	DsDisplayLine(0, 11, 240, 0, LINE_SOLID);
	DsDisplayWaitIconDraw(1);

	if (numRecords > 0)
		quicksort(0, numRecords - 1);
	
	DbEndTransaction(1,0);
	DbClose(dbHandle);

	
	/* Header */
	DsDisplayWaitIconDraw(0);
	DsClearScreen();
	DsPrintf(10, 0, TEXT_BOLD, "Name");

	if (type == 1)
		DsPrintf(130, 0, TEXT_BOLD, "Age");
	else if (type == 2)
		DsPrintf(120, 0, TEXT_BOLD, "Years");

	DsPrintf(160, 0, TEXT_BOLD, "Date");
	DsPrintf(230, 0, TEXT_BOLD, "X");
	DsDisplayLine(0, 11, 240, 0, LINE_SOLID);

	if (numRecords <= LINES_PER_PAGE) {
		maxPos = 0;
		DsDialogScrollBarDraw (220, 10, 110, 0);
	} else {
		maxPos = numRecords - LINES_PER_PAGE;
		DsDialogScrollBarDraw (220, 10, 110, maxPos + 1);
	}

	pos = 0;
	if (maxPos > 0)
		DsDialogScrollThumbSet(pos);

	if (numRecords > 0)
		displayRecords();

	return;
}

substr(output, input, beginPos, endPos) char *output, *input; int beginPos, endPos; {
    int i;
    char *temp;
    temp = input;
    temp += beginPos;
    for(i = beginPos; i <= endPos && i < 60; i++) {
        *output = *temp;
        *output++; *temp++;
    }
    *output='\0';
}

int compare(CRECORD *a, CRECORD *b)
{
	if (sortField == 0) {
		if ( (a->currYear > b->currYear) ||
			 ((a->currYear == b->currYear) && ((a->month > b->month) ||
			                                   ((a->month == b->month) && (a->day > b->day)))) )
									   return sortDir;

		else if ( (a->currYear < b->currYear) ||
			 ((a->currYear == b->currYear) && ((a->month < b->month) ||
			                                   ((a->month == b->month) && (a->day < b->day)))) )
									   return -sortDir;
		else
			return 0;
	} else if (sortField == 1) {
		return (strcmp(a->name, b->name) * sortDir);
	} else { /* sortField = 2 */
		if (a->age > b->age)
			return sortDir;
		else if (a->age < b->age)
			return -sortDir;
		else 
			return 0;
	}
}

void swap_records( CRECORD **a, CRECORD **b )
{
	CRECORD *tmp = *a;
	*a = *b;
	*b = tmp;
}
   

int partition( int low, int high )
{
	int left, right, pivot;
	CRECORD *pivot_item;

	pivot_item = records[low];
	pivot = left = low;
	right = high;

	while ( left < right ) {
		/* I compare in reverse order because I print the list in reverse */
		while( compare(records[left], pivot_item) <= 0 ) 
			left++;

		while( compare(records[right], pivot_item) > 0 ) 
			right--;

		if ( left < right ) 
			swap_records(&records[left], &records[right]);
	}

	/* right is final position for the pivot */
	records[low] = records[right];
	records[right] = pivot_item;

	return right;
}

void quicksort( int low, int high )
{
	int pivot;

	if ( high > low ) {
		pivot = partition(low, high );
		quicksort( low, pivot-1 );
		quicksort( pivot+1, high );
	}
}

void getMonthString(int month, char *monthStr)
{
	switch (month) {
	case 1:
		strcpy(monthStr, "Jan");
		break;
	case 2:
		strcpy(monthStr, "Feb");
		break;
	case 3:
		strcpy(monthStr, "Mar");
		break;
	case 4:
		strcpy(monthStr, "Apr");
		break;
	case 5:
		strcpy(monthStr, "May");
		break;
	case 6:
		strcpy(monthStr, "Jun");
		break;
	case 7:
		strcpy(monthStr, "Jul");
		break;
	case 8:
		strcpy(monthStr, "Aug");
		break;
	case 9:
		strcpy(monthStr, "Sep");
		break;
	case 10:
		strcpy(monthStr, "Oct");
		break;
	case 11:
		strcpy(monthStr, "Nov");
		break;
	case 12:
		strcpy(monthStr, "Dec");
		break;
	default:
		strcpy(monthStr, "Err");
		break;
	}
	return;
}

void displayRecords()
{
	char str[5];
	int line = 13, counter = 0, baseIndex = 0;

	if (numRecords == 0)
		return;

	if (pos > numRecords - LINES_PER_PAGE)
		baseIndex = numRecords - LINES_PER_PAGE - 1;
	else
		baseIndex = pos - 1;

	while ( counter < LINES_PER_PAGE) {
		counter++;
		if (baseIndex + counter < numRecords) {;
			if (records[baseIndex + counter]->age > 0) {
				DsPrintf(10, line, TEXT_NORMAL, records[baseIndex + counter]->name);

				itoa(str, records[baseIndex + counter]->age);

				if (recordType == 1) {
					if (records[baseIndex + counter]->age < 10) {
						DsPrintf(130, line, TEXT_NORMAL, " ");
						DsPrintf(135, line, TEXT_NORMAL, str);
					} else {
						DsPrintf(130, line, TEXT_NORMAL, str);
					}
				} else if (recordType == 2) {
					if (records[baseIndex + counter]->age < 10) {
						DsPrintf(120, line, TEXT_NORMAL, " ");
						DsPrintf(125, line, TEXT_NORMAL, str);
					} else {
						DsPrintf(120, line, TEXT_NORMAL, str);
					}
				}
	
				itoa(str, records[baseIndex + counter]->day);
				if (records[baseIndex + counter]->day < 10) {
				DsPrintf(160, line, TEXT_NORMAL, "0");					DsPrintf(165, line, TEXT_NORMAL, str);
				} else {
					DsPrintf(160, line, TEXT_NORMAL, str);
				}

				DsPrintf(170, line, TEXT_NORMAL, "-");
				getMonthString(records[baseIndex + counter]->month, str);
				DsPrintf(175, line, TEXT_NORMAL, str);

				DsPrintf(193, line, TEXT_NORMAL, "-");
				itoa(str, records[baseIndex + counter]->currYear);
				DsPrintf(198, line, TEXT_NORMAL, str);

				DsDisplayLine(0, line + 10, 219, 0, LINE_DOTTED);
				line += 12;
			}
		} else {
			break;
		}
	}
}

